import { Injectable } from '@angular/core';
import { IObjectListUIService } from '@objects-view/interfaces/object-list-ui-service';
import { Router } from '@angular/router';
import { ConfigService } from '@shared/config/config.service';
import { IBaseFleioObjectModel } from '@fleio-api/base-model/base-fleio-object.model';
import { IPermissionsModel } from '@fleio-api/base-model/IPermissionsModel';
import { IObjectUIService } from '@objects-view/interfaces/object-ui-service';
import { FleioObjectsList } from '@fleio-api/fleio-objects-list';
import { ITableData } from '@objects-view/interfaces/table-data/table-data';
import { ColumnType } from '@objects-view/interfaces/table-data/column-definition';
import { ITableRow } from '@objects-view/interfaces/table-data/table-row';
import { IAction } from '@objects-view/interfaces/actions/action';
import { InvitationUiService } from './invitation-ui.service';
import { YesNoPipe } from '@shared/ui/common/pipes/yes-no.pipe';
import { IClientModel } from '@fleio-api/client-user/model/client.model';
import { DateFormatterPipe } from '@shared/ui/common/pipes/date-formatter.pipe';

@Injectable({
  providedIn: 'root'
})
export class InvitationListUiService implements IObjectListUIService {
  public noItemsMessage = $localize`No invitations`;
  private datePipe: DateFormatterPipe;
  private yesNoPipe: YesNoPipe;

  constructor(
    private router: Router, private config: ConfigService,
  ) {
    this.datePipe = new DateFormatterPipe(this.config);
    this.yesNoPipe = new YesNoPipe();
  }

  getObjectUIService(
    object: IBaseFleioObjectModel, permissions: IPermissionsModel, state: string
  ): IObjectUIService {
    return new InvitationUiService(
      object as IClientModel, permissions, state, this.router, this.config,
    );
  }

  getTableData(objectList: FleioObjectsList<IClientModel>): ITableData {
    const tableData: ITableData = {
      header: {
        columns: [
          {
            type: ColumnType.Value, displayName: $localize`Name`, enableSort: true, fieldName: 'name',
            flex: '1 0 150px', flexXs: '1 0 100px',
          },
          {
            type: ColumnType.Value, displayName: $localize`Roles`, enableSort: true, fieldName: 'roles',
            flex: '1 0 150px',
          },
          {
            type: ColumnType.Actions, displayName: $localize`Actions`, enableSort: false, fieldName: '(actions)',
          },
        ],
        columnNames: ['name', 'roles', '(actions)'],
        showStatus: true,
      },
      rows: [],
    };

    for (const object of objectList.objects) {
      const rowUIService = this.getObjectUIService(object, objectList.permissions, 'table-view');
      const roles = object.roles.map(role => role.display_name).join(',');
      const row: ITableRow = {
        cells: {
          name: {text: object.name},
          roles: {text: roles},
        },
        icon: rowUIService.getIcon(),
        status: rowUIService.getStatus(),
        actions: rowUIService.getActions(),
        url: rowUIService.getDetailsLink(),
        object,
      };

      tableData.trackByFunction = (index, item: ITableRow) => item.object.id;
      tableData.rows.push(row);
    }

    return tableData;
  }

  getActions(objectList: FleioObjectsList<IBaseFleioObjectModel>): IAction[] {
    return [];
  }

  getRefreshInterval(): number {
    if (this.config && this.config.current && this.config.current.settings &&
      this.config.current.settings.refreshIntervals) {
      return this.config.current.settings.refreshIntervals.defaultInterval;
    }
    return 10000;
  }
}
